unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,StdCtrls,
  Dialogs, GLCrossPlatform, BaseClasses,
  GLScene, GLWin32Viewer, GLObjects,
  GLGeomObjects, GLCoordinates,
  VectorTypes, VectorGeometry ;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    Raiz: TGLDummyCube;
    GLLightSource2: TGLLightSource;
    Button1: TButton;

    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    px,py  : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;

end;

// silla en base  poligonos
procedure TForm1.Button1Click(Sender: TObject);
var
  poly : TGLPolygon;
  vv   : array [0..11] of TVector3f;
begin
  SetVector(vv[0],  30, 70, 0);
  SetVector(vv[1], -30, 70, 0);
  SetVector(vv[2], -30,-50, 0);
  SetVector(vv[3],  30,-50, 0);
  SetVector(vv[4], -30,  0, 0);
  SetVector(vv[5],  30,  0, 0);
  SetVector(vv[6], -30,  0,50);
  SetVector(vv[7],  30,  0,50);
  SetVector(vv[8], -30,-50,50);
  SetVector(vv[9],  30,-50,50);
  SetVector(vv[10],-30,-25,25);
  SetVector(vv[11], 30,-25,25);

  // pol-1
  poly := TGLPolygon.Create(self);
  poly.Parent := Raiz;
  poly.Scale.Scale(0.02);

  poly.Nodes.AddNode(vv[0]) ;
  poly.Nodes.AddNode(vv[1]) ;
  poly.Nodes.AddNode(vv[2]) ;
  poly.Nodes.AddNode(vv[3]) ;

  // pol-2
  poly := TGLPolygon.Create(self);
  poly.Parent := Raiz;
  poly.Scale.Scale(0.02);

  poly.Nodes.AddNode(vv[4]) ;
  poly.Nodes.AddNode(vv[5]) ;
  poly.Nodes.AddNode(vv[7]) ;
  poly.Nodes.AddNode(vv[6]) ;

  // pol-3
  poly := TGLPolygon.Create(self);
  poly.Parent := Raiz;
  poly.Scale.Scale(0.02);

  poly.Nodes.AddNode(vv[4]) ;
  poly.Nodes.AddNode(vv[6]) ;
  poly.Nodes.AddNode(vv[8]) ;
  poly.Nodes.AddNode(vv[10]) ;
  poly.Nodes.AddNode(vv[2]) ;

  // pol-4
  poly := TGLPolygon.Create(self);
  poly.Parent := Raiz;
  poly.Scale.Scale(0.02);

  poly.Nodes.AddNode(vv[7]) ;
  poly.Nodes.AddNode(vv[5]) ;
  poly.Nodes.AddNode(vv[3]) ;
  poly.Nodes.AddNode(vv[11]) ;
  poly.Nodes.AddNode(vv[9]) ;

end;



end.
